//-----------------------------------------------------------------------------
// main.m
//
// handles custom Items in the main mode
//   --oi, this has become quite a mess...if anyone is looking to this to learn
//   ive gone throught and commented what does what 
//
// by iPlayTheSpoons
//
//-----------------------------------------------------------------------------

#include "../../../lib/std.mi"

Function UpdateVis(Int Var);
Function ModeSwitch();

Global Container MainContainer;
Global Layout NormalLayout, ShadeLayout, StickLayout;
Global Group LCD, Equalizer, CButtons, TopDrawer, BottomDrawer, Sliders;
Global AnimatedLayer MainVis;
Global Button EQLayer, PlayButton, PauseButton, TopUp, TopDown, BotUp, BotDown;
Global Button A,B,C,X,Y,Z, ShadePlay, ShadePause;
Global Button NormSwitch, ShadeSwitch, StickSwitch, StickPause, StickPlay;
Global Slider StickVol, StickSeek;
Global Text StickTick;
Global Timer VisTimer,StickTextTimer;
Global Double Level, OneFrame;
Global Int LastFrame, EQstatus, VisStatus, intSelection;
Global PopupMenu TickPop, SwitchPop;

System.onScriptLoaded() { 

	MainContainer = getContainer("main");
	NormalLayout = MainContainer.getLayout("normal");
	ShadeLayout = MainContainer.getLayout("shade");
	StickLayout = MainContainer.getLayout("stick");
	Group TopCont = ShadeLayout.getObject("top.drawer.conatiner");
	Group BottomCont = ShadeLayout.getObject("bottom.drawer.conatiner");
	Group ShadeCB = ShadeLayout.getObject("shade.cbuttons");
	Group NormSystem = NormalLayout.getObject("mainarray");
	Group StickSystem = StickLayout.getObject("stick.buttons");
	Group StickLCD = StickLayout.getObject("stick.lcd");
	
	StickTick = StickLCD.getObject("SongTicker");
	Sliders = StickLayout.getObject("sliders");
	StickVol = Sliders.getObject("vol");
	StickSeek = Sliders.getObject("seek");
	TopDrawer = TopCont.getObject("top.drawer");
	BottomDrawer = BottomCont.getObject("bottom.drawer");
	TopUp = TopDrawer.getObject("arrow.up");
	TopDown = TopDrawer.getObject("arrow.down");
	BotUp = BottomDrawer.getObject("arrow.up");
	BotDown = BottomDrawer.getObject("arrow.down"); 
	A = BottomDrawer.getObject("shuffle");
	B = BottomDrawer.getObject("repeat");
	C = BottomDrawer.getObject("xfader");
	X = TopDrawer.getObject("close");
	Y = TopDrawer.getObject("min");
	Z = TopDrawer.getObject("switch");
	ShadeSwitch = TopDrawer.getObject("switch");
	ShadePlay = ShadeCB.getObject("play");
	ShadePause = ShadeCB.getObject("pause");
	StickPlay = StickSystem.getObject("play");
	StickPause = StickSystem.getObject("pause");
	NormSwitch = NormSystem.getObject("switch");
	StickSwitch = StickSystem.getObject("switch");
	
	LCD = NormalLayout.getObject("lcd");
	Equalizer = LCD.getObject("equalizer");
	EQLayer = Equalizer.getObject("eq.back");
	MainVis = LCD.getObject("MainVis");
	CButtons = NormalLayout.getObject("cbuttons");
	PlayButton = CButtons.getObject("Play");
	PauseButton = CButtons.getObject("Pause");

	VisTimer = new Timer;
	VisTimer.setDelay(50);
	VisTimer.start();
	StickTextTimer = new Timer;
	StickTextTimer.setDelay(2500);
	MainVis.setSpeed(50);
	OneFrame = 255/7;
	EQstatus = 0;
	VisStatus = 1;
	
//creates mode switch menu
	SwitchPop = new PopupMenu;
		SwitchPop.addCommand(" Mode Select ",-1,0,0);
		SwitchPop.addSeparator();
		SwitchPop.addCommand(" Normal ",2,0,0);
		SwitchPop.addCommand(" Shade ",3,0,0);
		SwitchPop.addCommand(" Stick ",4,0,0);
		SwitchPop.disableCommand(1, 0);
//------------------	
//sets if play or pause button shows on load		
	if (System.getStatus() == 1) {
		PlayButton.hide();
		PauseButton.show();
		ShadePlay.hide();
		ShadePause.show();
		StickPlay.hide();
		StickPause.show();
	}
	else if (System.getStatus() != 1) {
		PlayButton.show();
		PauseButton.hide();
		ShadePlay.show();
		ShadePause.hide();
		StickPlay.show();
		StickPause.hide();
	}
//------------------
//sets drawers positions onload (remembering from the last time)
	If (System.getPrivateInt("PAD", "EQ_Position", 0) == 1) {
		EQLayer.leftClick();
	}	
	If (System.getPrivateInt("PAD", "TopSlide_Pos", 1) == 0) {
		TopDown.leftClick();
	}
	If (System.getPrivateInt("PAD", "TopSlide_Pos", 1) == 1) {
		TopUp.leftClick();
	}
	If (System.getPrivateInt("PAD", "BotSlide_Pos", 0) == 0) {
		BotDown.leftClick();
	}
	If (System.getPrivateInt("PAD", "BotSlide_Pos", 0) == 1) {
		BotUp.leftClick();
	}
//------------------
//sets if stick transition drawer should go	
	if(System.getPrivateString("PAD", "CurrentLayout", "Normal") == "Stick"){
	Sliders.setTargetY(34);
	Sliders.setTargetSpeed(0.7);
	Sliders.gotoTarget();
//------------------
}
}

System.onScriptUnloading() {
  VisTimer.stop();
  delete StickTextTimer;
  delete VisTimer;
}

//sets volume level text thing in stick mode
System.onVolumeChanged(int Position) {
	StickTick.setText("Volume: " + system.integertostring((Position*100)/255) + "%");
	StickTextTimer.start();
}

StickTextTimer.onTimer() {
	StickTick.setText("");
	StickTextTimer.stop();
}
//------------------	
//*very messy* drawers in shade mode
TopUp.onLeftClick() {
	System.setPrivateInt("PAD", "TopSlide_Pos", 1);
	X.setXMLParam("ghost","0");
	Y.setXMLParam("ghost","0");
	Z.setXMLParam("ghost","0");
	TopDrawer.setTargetY(0);
	TopDrawer.setTargetSpeed(0.3);
	TopDrawer.gotoTarget();
	TopUp.hide();
	TopDown.show();
}

TopDown.onLeftClick() {
	System.setPrivateInt("PAD", "TopSlide_Pos", 0);
	X.setXMLParam("ghost","1");
	Y.setXMLParam("ghost","1");
	Z.setXMLParam("ghost","1");
	TopDrawer.setTargetY(18);
	TopDrawer.setTargetSpeed(0.3);
	TopDrawer.gotoTarget();
	TopUp.show();
	TopDown.hide();
}

BotUp.onLeftClick() {
	System.setPrivateInt("PAD", "BotSlide_Pos", 1);
	A.setXMLParam("ghost","1");
	B.setXMLParam("ghost","1");
	C.setXMLParam("ghost","1");
	BottomDrawer.setTargetY(-25);
	BottomDrawer.setTargetSpeed(0.3);
	BottomDrawer.gotoTarget();
	BotUp.hide();
	BotDown.show();
}

BotDown.onLeftClick() {
	System.setPrivateInt("PAD", "BotSlide_Pos", 0);
	A.setXMLParam("ghost","0");
	B.setXMLParam("ghost","0");
	C.setXMLParam("ghost","0");
	BottomDrawer.setTargetY(0);
	BottomDrawer.setTargetSpeed(0.3);
	BottomDrawer.gotoTarget();
	BotUp.show();
	BotDown.hide();
}
//------------------
//controls custom vis in the lcd
VisTimer.onTimer() {
	Level = ((System.getLeftVuMeter() + System.getRightVuMeter())/2);
		UpdateVis(Level/OneFrame);
}

MainVis.onLeftButtonUp(int x, int y){
	if(VisStatus == 1)
	{
		VisStatus=0;
		VisTimer.stop();
		MainVis.setStartFrame(LastFrame);
     	MainVis.setEndFrame(0);
		MainVis.setSpeed(250);
		MainVis.play();
		MainVis.setAutoReplay(0);
	}
	else if(VisStatus == 0)
	{
		VisStatus=1;
		VisTimer.start();
		MainVis.setSpeed(50);
	}
}
		
UpdateVis(Int Var){
	{
		MainVis.setStartFrame(LastFrame);
     	MainVis.setEndFrame(Var);
     	MainVis.play();
     	LastFrame = Var;
	}
}
//------------------
//Equalizer drawer in the main mode
EQLayer.onLeftClick(){
	if(EQstatus == 0){
		EQstatus = 1;
		System.setPrivateInt("PAD", "EQ_Position", 1);
		Equalizer.setTargetY(2);
		Equalizer.setTargetSpeed(0.5);
		Equalizer.gotoTarget();
	}
	else if(EQstatus == 1){
		EQstatus = 0;
		System.setPrivateInt("PAD", "EQ_Position", 0);
		Equalizer.setTargetY(-87);
		Equalizer.setTargetSpeed(0.5);
		Equalizer.gotoTarget();
	}
}
//------------------
//control showing and hiding on play/pause buttons
System.onPlay() {
	PlayButton.hide();
	PauseButton.show();
	ShadePlay.hide();
	ShadePause.show();
	StickPlay.hide();
	StickPause.show();
}
System.onResume() {
	PlayButton.hide();
	PauseButton.show();
	ShadePlay.hide();
	ShadePause.show();
	StickPlay.hide();
	StickPause.show();
}
System.onStop() {
	PlayButton.show();
	PauseButton.hide();
	ShadePlay.show();
	ShadePause.hide();
	StickPlay.show();
	StickPause.hide();
}
System.onPause() {
	PlayButton.show();
	PauseButton.hide();
	ShadePlay.show();
	ShadePause.hide();
	StickPlay.show();
	StickPause.hide();
}
//------------------
//mode switching
NormSwitch.onLeftClick(){ 
	ModeSwitch();
}	
ShadeSwitch.onLeftClick(){  
	ModeSwitch();
}	
StickSwitch.onLeftClick(){ 
	ModeSwitch();
}

ModeSwitch() {
	intSelection = SwitchPop.popAtMouse();
		if (intSelection > 0) {
			if (intSelection==2) {
				System.setPrivateString("PAD", "CurrentLayout", "Normal");
				Sliders.setTargetY(18);
				Sliders.setTargetSpeed(0.7);
				Sliders.gotoTarget();
			} 
			else if (intSelection==3) {
				System.setPrivateString("PAD", "CurrentLayout", "Shade");
				Sliders.setTargetY(18);
				Sliders.setTargetSpeed(0.7);
				Sliders.gotoTarget();
			}
			else if (intSelection==4) {
				System.setPrivateString("PAD", "CurrentLayout", "Stick");
				MainContainer.switchToLayout("stick");
				Sliders.setTargetY(34);
				Sliders.setTargetSpeed(0.7);
				Sliders.gotoTarget();
			}
	}
	Complete;
}

Sliders.onTargetReached(){
	if (intSelection==2) {
			MainContainer.switchToLayout("normal");
	}
	else if (intSelection==3) {
			MainContainer.switchToLayout("shade");
	}
}
