// ****************************
// **    Old Winamp timer    **
// ****************************
// by ThePlague
// - brings back the old Winamp
//   timer [00:00] instead of
//   the new one [0:00]
// - NO xml changes needed!!
// - even links normal and
//   shade timers!

// modified by iPlayTheSpoons for three layouts :)

#include <lib/std.mi>

Function String oldTimer(int CurPos);

Global Timer tmrWait;
Global Text txtTimer,txtTimerShade,txtTimerStick;
Global Boolean MinusIsOn;

System.onScriptLoaded() {
  Container MainContainer = getContainer("main");
  Layout NormalLayout = MainContainer.getLayout("normal");
  Layout ShadeLayout = MainContainer.getLayout("shade");
  Layout StickLayout = MainContainer.getLayout("stick");
	
  Group LCD = NormalLayout.getObject("lcd");
  Group shadeLCD = ShadeLayout.getObject("shade.lcd");
  Group stickLCD = StickLayout.getObject("stick.lcd");
  txtTimer = LCD.getObject("time");
  txtTimerShade = shadeLCD.getObject("time");
  txtTimerStick = stickLCD.getObject("time");


  tmrWait = new Timer;
  tmrWait.setDelay(20);

  MinusIsOn = getPrivateInt("Settings", "Minus", 1);

  if (System.getStatus()==1) tmrWait.start();
}

System.onScriptUnloading() {
  tmrWait.stop();
  delete tmrWait;
}

System.onPlay() {
  tmrWait.start();
}

System.onStop() {
  tmrWait.stop();
  txtTimer.setText("");
  txtTimerShade.setText("");
  txtTimerStick.setText("");
}

tmrWait.onTimer() {
  if (MinusIsOn) txtTimer.setText(oldTimer(getPlayItemLength()-getPosition()));
  else txtTimer.setText(oldTimer(getPosition()));

  if (MinusIsOn) txtTimerShade.setText(oldTimer(getPlayItemLength()-getPosition()));
  else txtTimerShade.setText(oldTimer(getPosition()));
  
  if (MinusIsOn) txtTimerStick.setText(oldTimer(getPlayItemLength()-getPosition()));
  else txtTimerStick.setText(oldTimer(getPosition()));
}

txtTimer.onLeftButtonDown(int x, int y) {
  if (MinusIsOn) MinusIsOn=0;
  else MinusIsOn=1;
  setPrivateInt("Settings","Minus", MinusIsOn);
}

txtTimerShade.onLeftButtonDown(int x, int y) {
  if (MinusIsOn) MinusIsOn=0;
  else MinusIsOn=1;
  setPrivateInt("Settings","Minus", MinusIsOn);
}

txtTimerStick.onLeftButtonDown(int x, int y) {
  if (MinusIsOn) MinusIsOn=0;
  else MinusIsOn=1;
  setPrivateInt("Settings","Minus", MinusIsOn);
}

String oldTimer(int CurPos) {
  String SpecTmr = integerToTime(CurPos);
  String Temp = integerToString(CurPos);
  int TempLen = strlen(Temp);

  if (strlen(SpecTmr)==4) SpecTmr = "0" + SpecTmr;

  if (MinusIsOn) SpecTmr = "-" + SpecTmr;
  else SpecTmr = " " + SpecTmr;

  return SpecTmr;
}
